--TEST--
nulls
--SKIPIF--
--FILE--
<?php
require_once dirname(__FILE__) . '/../common/config.php';

$mysql = get_mysql_connection();

init_mysql_testdb($mysql);

$table = 'hstesttbl';
$tablesize = 256;
$sql = sprintf(
    'CREATE TABLE %s ( ' .
    'k varchar(30) PRIMARY KEY, ' .
    'v1 varchar(30), ' .
    'v2 varchar(30)) ' .
    'Engine = innodb default charset = binary',
    mysql_real_escape_string($table));
if (!mysql_query($sql, $mysql))
{
    die(mysql_error());
}

// setting null
echo 'HSINSERT', PHP_EOL;

$hs = new HandlerSocket(MYSQL_HOST, MYSQL_HANDLERSOCKET_PORT_WR);
if (!($hs->openIndex(1, MYSQL_DBNAME, $table, '', 'k,v1,v2')))
{
    die();
}

for ($i = 0; $i < $tablesize; $i++)
{
    $k = '' . $i;
    $v1 = 'v1_' . $i;
    $v2 = null; //null value

    $retval = $hs->executeInsert(1, array($k, $v1, $v2));
    if ($retval === false)
    {
        echo $hs->getError(), PHP_EOL;
    }
}
unset($hs);

dump_table($mysql, $table);

// setting null
echo 'HSUPDATE', PHP_EOL;
$hs = new HandlerSocket(MYSQL_HOST, MYSQL_HANDLERSOCKET_PORT_WR);
if (!($hs->openIndex(2, MYSQL_DBNAME, $table, '', 'v1')))
{
    die();
}

for ($i = 0; $i < $tablesize; $i++)
{
    $retval = $hs->executeSingle(2, '=', array($i), 1000, 0, 'U', array(null));
    if ($retval === false)
    {
        echo $hs->getError(), PHP_EOL;
    }
}
unset($hs);

dump_table($mysql, $table);

// setting non-null
echo 'HSUPDATE', PHP_EOL;
$hs = new HandlerSocket(MYSQL_HOST, MYSQL_HANDLERSOCKET_PORT_WR);
if (!($hs->openIndex(2, MYSQL_DBNAME, $table, '', 'v1')))
{
    die();
}

for ($i = 0; $i < $tablesize; $i++)
{
    $retval = $hs->executeSingle(2, '=', array($i), 1000, 0, 'U', array('hoge'));
    if ($retval === false)
    {
        echo $hs->getError(), PHP_EOL;
    }
}
unset($hs);

dump_table($mysql, $table);


function dump_table($mysql, $table)
{
    echo 'DUMP_TABLE', PHP_EOL;
    $sql = 'SELECT k,v1,v2 FROM ' . $table . ' ORDER BY k';
    $result = mysql_query($sql, $mysql);
    if ($result)
    {
        while ($row = mysql_fetch_assoc($result))
        {
            if (!$row['v1'])
            {
                $row['v1'] = '[NULL]';
            }
            if (!$row['v2'])
            {
                $row['v2'] = '[NULL]';
            }
            echo $row['k'], ' ', $row['v1'], ' ', $row['v2'], PHP_EOL;
        }
    }
    mysql_free_result($result);
}

mysql_close($mysql);

--EXPECT--
HSINSERT
DUMP_TABLE
0 v1_0 [NULL]
1 v1_1 [NULL]
10 v1_10 [NULL]
100 v1_100 [NULL]
101 v1_101 [NULL]
102 v1_102 [NULL]
103 v1_103 [NULL]
104 v1_104 [NULL]
105 v1_105 [NULL]
106 v1_106 [NULL]
107 v1_107 [NULL]
108 v1_108 [NULL]
109 v1_109 [NULL]
11 v1_11 [NULL]
110 v1_110 [NULL]
111 v1_111 [NULL]
112 v1_112 [NULL]
113 v1_113 [NULL]
114 v1_114 [NULL]
115 v1_115 [NULL]
116 v1_116 [NULL]
117 v1_117 [NULL]
118 v1_118 [NULL]
119 v1_119 [NULL]
12 v1_12 [NULL]
120 v1_120 [NULL]
121 v1_121 [NULL]
122 v1_122 [NULL]
123 v1_123 [NULL]
124 v1_124 [NULL]
125 v1_125 [NULL]
126 v1_126 [NULL]
127 v1_127 [NULL]
128 v1_128 [NULL]
129 v1_129 [NULL]
13 v1_13 [NULL]
130 v1_130 [NULL]
131 v1_131 [NULL]
132 v1_132 [NULL]
133 v1_133 [NULL]
134 v1_134 [NULL]
135 v1_135 [NULL]
136 v1_136 [NULL]
137 v1_137 [NULL]
138 v1_138 [NULL]
139 v1_139 [NULL]
14 v1_14 [NULL]
140 v1_140 [NULL]
141 v1_141 [NULL]
142 v1_142 [NULL]
143 v1_143 [NULL]
144 v1_144 [NULL]
145 v1_145 [NULL]
146 v1_146 [NULL]
147 v1_147 [NULL]
148 v1_148 [NULL]
149 v1_149 [NULL]
15 v1_15 [NULL]
150 v1_150 [NULL]
151 v1_151 [NULL]
152 v1_152 [NULL]
153 v1_153 [NULL]
154 v1_154 [NULL]
155 v1_155 [NULL]
156 v1_156 [NULL]
157 v1_157 [NULL]
158 v1_158 [NULL]
159 v1_159 [NULL]
16 v1_16 [NULL]
160 v1_160 [NULL]
161 v1_161 [NULL]
162 v1_162 [NULL]
163 v1_163 [NULL]
164 v1_164 [NULL]
165 v1_165 [NULL]
166 v1_166 [NULL]
167 v1_167 [NULL]
168 v1_168 [NULL]
169 v1_169 [NULL]
17 v1_17 [NULL]
170 v1_170 [NULL]
171 v1_171 [NULL]
172 v1_172 [NULL]
173 v1_173 [NULL]
174 v1_174 [NULL]
175 v1_175 [NULL]
176 v1_176 [NULL]
177 v1_177 [NULL]
178 v1_178 [NULL]
179 v1_179 [NULL]
18 v1_18 [NULL]
180 v1_180 [NULL]
181 v1_181 [NULL]
182 v1_182 [NULL]
183 v1_183 [NULL]
184 v1_184 [NULL]
185 v1_185 [NULL]
186 v1_186 [NULL]
187 v1_187 [NULL]
188 v1_188 [NULL]
189 v1_189 [NULL]
19 v1_19 [NULL]
190 v1_190 [NULL]
191 v1_191 [NULL]
192 v1_192 [NULL]
193 v1_193 [NULL]
194 v1_194 [NULL]
195 v1_195 [NULL]
196 v1_196 [NULL]
197 v1_197 [NULL]
198 v1_198 [NULL]
199 v1_199 [NULL]
2 v1_2 [NULL]
20 v1_20 [NULL]
200 v1_200 [NULL]
201 v1_201 [NULL]
202 v1_202 [NULL]
203 v1_203 [NULL]
204 v1_204 [NULL]
205 v1_205 [NULL]
206 v1_206 [NULL]
207 v1_207 [NULL]
208 v1_208 [NULL]
209 v1_209 [NULL]
21 v1_21 [NULL]
210 v1_210 [NULL]
211 v1_211 [NULL]
212 v1_212 [NULL]
213 v1_213 [NULL]
214 v1_214 [NULL]
215 v1_215 [NULL]
216 v1_216 [NULL]
217 v1_217 [NULL]
218 v1_218 [NULL]
219 v1_219 [NULL]
22 v1_22 [NULL]
220 v1_220 [NULL]
221 v1_221 [NULL]
222 v1_222 [NULL]
223 v1_223 [NULL]
224 v1_224 [NULL]
225 v1_225 [NULL]
226 v1_226 [NULL]
227 v1_227 [NULL]
228 v1_228 [NULL]
229 v1_229 [NULL]
23 v1_23 [NULL]
230 v1_230 [NULL]
231 v1_231 [NULL]
232 v1_232 [NULL]
233 v1_233 [NULL]
234 v1_234 [NULL]
235 v1_235 [NULL]
236 v1_236 [NULL]
237 v1_237 [NULL]
238 v1_238 [NULL]
239 v1_239 [NULL]
24 v1_24 [NULL]
240 v1_240 [NULL]
241 v1_241 [NULL]
242 v1_242 [NULL]
243 v1_243 [NULL]
244 v1_244 [NULL]
245 v1_245 [NULL]
246 v1_246 [NULL]
247 v1_247 [NULL]
248 v1_248 [NULL]
249 v1_249 [NULL]
25 v1_25 [NULL]
250 v1_250 [NULL]
251 v1_251 [NULL]
252 v1_252 [NULL]
253 v1_253 [NULL]
254 v1_254 [NULL]
255 v1_255 [NULL]
26 v1_26 [NULL]
27 v1_27 [NULL]
28 v1_28 [NULL]
29 v1_29 [NULL]
3 v1_3 [NULL]
30 v1_30 [NULL]
31 v1_31 [NULL]
32 v1_32 [NULL]
33 v1_33 [NULL]
34 v1_34 [NULL]
35 v1_35 [NULL]
36 v1_36 [NULL]
37 v1_37 [NULL]
38 v1_38 [NULL]
39 v1_39 [NULL]
4 v1_4 [NULL]
40 v1_40 [NULL]
41 v1_41 [NULL]
42 v1_42 [NULL]
43 v1_43 [NULL]
44 v1_44 [NULL]
45 v1_45 [NULL]
46 v1_46 [NULL]
47 v1_47 [NULL]
48 v1_48 [NULL]
49 v1_49 [NULL]
5 v1_5 [NULL]
50 v1_50 [NULL]
51 v1_51 [NULL]
52 v1_52 [NULL]
53 v1_53 [NULL]
54 v1_54 [NULL]
55 v1_55 [NULL]
56 v1_56 [NULL]
57 v1_57 [NULL]
58 v1_58 [NULL]
59 v1_59 [NULL]
6 v1_6 [NULL]
60 v1_60 [NULL]
61 v1_61 [NULL]
62 v1_62 [NULL]
63 v1_63 [NULL]
64 v1_64 [NULL]
65 v1_65 [NULL]
66 v1_66 [NULL]
67 v1_67 [NULL]
68 v1_68 [NULL]
69 v1_69 [NULL]
7 v1_7 [NULL]
70 v1_70 [NULL]
71 v1_71 [NULL]
72 v1_72 [NULL]
73 v1_73 [NULL]
74 v1_74 [NULL]
75 v1_75 [NULL]
76 v1_76 [NULL]
77 v1_77 [NULL]
78 v1_78 [NULL]
79 v1_79 [NULL]
8 v1_8 [NULL]
80 v1_80 [NULL]
81 v1_81 [NULL]
82 v1_82 [NULL]
83 v1_83 [NULL]
84 v1_84 [NULL]
85 v1_85 [NULL]
86 v1_86 [NULL]
87 v1_87 [NULL]
88 v1_88 [NULL]
89 v1_89 [NULL]
9 v1_9 [NULL]
90 v1_90 [NULL]
91 v1_91 [NULL]
92 v1_92 [NULL]
93 v1_93 [NULL]
94 v1_94 [NULL]
95 v1_95 [NULL]
96 v1_96 [NULL]
97 v1_97 [NULL]
98 v1_98 [NULL]
99 v1_99 [NULL]
HSUPDATE
DUMP_TABLE
0 [NULL] [NULL]
1 [NULL] [NULL]
10 [NULL] [NULL]
100 [NULL] [NULL]
101 [NULL] [NULL]
102 [NULL] [NULL]
103 [NULL] [NULL]
104 [NULL] [NULL]
105 [NULL] [NULL]
106 [NULL] [NULL]
107 [NULL] [NULL]
108 [NULL] [NULL]
109 [NULL] [NULL]
11 [NULL] [NULL]
110 [NULL] [NULL]
111 [NULL] [NULL]
112 [NULL] [NULL]
113 [NULL] [NULL]
114 [NULL] [NULL]
115 [NULL] [NULL]
116 [NULL] [NULL]
117 [NULL] [NULL]
118 [NULL] [NULL]
119 [NULL] [NULL]
12 [NULL] [NULL]
120 [NULL] [NULL]
121 [NULL] [NULL]
122 [NULL] [NULL]
123 [NULL] [NULL]
124 [NULL] [NULL]
125 [NULL] [NULL]
126 [NULL] [NULL]
127 [NULL] [NULL]
128 [NULL] [NULL]
129 [NULL] [NULL]
13 [NULL] [NULL]
130 [NULL] [NULL]
131 [NULL] [NULL]
132 [NULL] [NULL]
133 [NULL] [NULL]
134 [NULL] [NULL]
135 [NULL] [NULL]
136 [NULL] [NULL]
137 [NULL] [NULL]
138 [NULL] [NULL]
139 [NULL] [NULL]
14 [NULL] [NULL]
140 [NULL] [NULL]
141 [NULL] [NULL]
142 [NULL] [NULL]
143 [NULL] [NULL]
144 [NULL] [NULL]
145 [NULL] [NULL]
146 [NULL] [NULL]
147 [NULL] [NULL]
148 [NULL] [NULL]
149 [NULL] [NULL]
15 [NULL] [NULL]
150 [NULL] [NULL]
151 [NULL] [NULL]
152 [NULL] [NULL]
153 [NULL] [NULL]
154 [NULL] [NULL]
155 [NULL] [NULL]
156 [NULL] [NULL]
157 [NULL] [NULL]
158 [NULL] [NULL]
159 [NULL] [NULL]
16 [NULL] [NULL]
160 [NULL] [NULL]
161 [NULL] [NULL]
162 [NULL] [NULL]
163 [NULL] [NULL]
164 [NULL] [NULL]
165 [NULL] [NULL]
166 [NULL] [NULL]
167 [NULL] [NULL]
168 [NULL] [NULL]
169 [NULL] [NULL]
17 [NULL] [NULL]
170 [NULL] [NULL]
171 [NULL] [NULL]
172 [NULL] [NULL]
173 [NULL] [NULL]
174 [NULL] [NULL]
175 [NULL] [NULL]
176 [NULL] [NULL]
177 [NULL] [NULL]
178 [NULL] [NULL]
179 [NULL] [NULL]
18 [NULL] [NULL]
180 [NULL] [NULL]
181 [NULL] [NULL]
182 [NULL] [NULL]
183 [NULL] [NULL]
184 [NULL] [NULL]
185 [NULL] [NULL]
186 [NULL] [NULL]
187 [NULL] [NULL]
188 [NULL] [NULL]
189 [NULL] [NULL]
19 [NULL] [NULL]
190 [NULL] [NULL]
191 [NULL] [NULL]
192 [NULL] [NULL]
193 [NULL] [NULL]
194 [NULL] [NULL]
195 [NULL] [NULL]
196 [NULL] [NULL]
197 [NULL] [NULL]
198 [NULL] [NULL]
199 [NULL] [NULL]
2 [NULL] [NULL]
20 [NULL] [NULL]
200 [NULL] [NULL]
201 [NULL] [NULL]
202 [NULL] [NULL]
203 [NULL] [NULL]
204 [NULL] [NULL]
205 [NULL] [NULL]
206 [NULL] [NULL]
207 [NULL] [NULL]
208 [NULL] [NULL]
209 [NULL] [NULL]
21 [NULL] [NULL]
210 [NULL] [NULL]
211 [NULL] [NULL]
212 [NULL] [NULL]
213 [NULL] [NULL]
214 [NULL] [NULL]
215 [NULL] [NULL]
216 [NULL] [NULL]
217 [NULL] [NULL]
218 [NULL] [NULL]
219 [NULL] [NULL]
22 [NULL] [NULL]
220 [NULL] [NULL]
221 [NULL] [NULL]
222 [NULL] [NULL]
223 [NULL] [NULL]
224 [NULL] [NULL]
225 [NULL] [NULL]
226 [NULL] [NULL]
227 [NULL] [NULL]
228 [NULL] [NULL]
229 [NULL] [NULL]
23 [NULL] [NULL]
230 [NULL] [NULL]
231 [NULL] [NULL]
232 [NULL] [NULL]
233 [NULL] [NULL]
234 [NULL] [NULL]
235 [NULL] [NULL]
236 [NULL] [NULL]
237 [NULL] [NULL]
238 [NULL] [NULL]
239 [NULL] [NULL]
24 [NULL] [NULL]
240 [NULL] [NULL]
241 [NULL] [NULL]
242 [NULL] [NULL]
243 [NULL] [NULL]
244 [NULL] [NULL]
245 [NULL] [NULL]
246 [NULL] [NULL]
247 [NULL] [NULL]
248 [NULL] [NULL]
249 [NULL] [NULL]
25 [NULL] [NULL]
250 [NULL] [NULL]
251 [NULL] [NULL]
252 [NULL] [NULL]
253 [NULL] [NULL]
254 [NULL] [NULL]
255 [NULL] [NULL]
26 [NULL] [NULL]
27 [NULL] [NULL]
28 [NULL] [NULL]
29 [NULL] [NULL]
3 [NULL] [NULL]
30 [NULL] [NULL]
31 [NULL] [NULL]
32 [NULL] [NULL]
33 [NULL] [NULL]
34 [NULL] [NULL]
35 [NULL] [NULL]
36 [NULL] [NULL]
37 [NULL] [NULL]
38 [NULL] [NULL]
39 [NULL] [NULL]
4 [NULL] [NULL]
40 [NULL] [NULL]
41 [NULL] [NULL]
42 [NULL] [NULL]
43 [NULL] [NULL]
44 [NULL] [NULL]
45 [NULL] [NULL]
46 [NULL] [NULL]
47 [NULL] [NULL]
48 [NULL] [NULL]
49 [NULL] [NULL]
5 [NULL] [NULL]
50 [NULL] [NULL]
51 [NULL] [NULL]
52 [NULL] [NULL]
53 [NULL] [NULL]
54 [NULL] [NULL]
55 [NULL] [NULL]
56 [NULL] [NULL]
57 [NULL] [NULL]
58 [NULL] [NULL]
59 [NULL] [NULL]
6 [NULL] [NULL]
60 [NULL] [NULL]
61 [NULL] [NULL]
62 [NULL] [NULL]
63 [NULL] [NULL]
64 [NULL] [NULL]
65 [NULL] [NULL]
66 [NULL] [NULL]
67 [NULL] [NULL]
68 [NULL] [NULL]
69 [NULL] [NULL]
7 [NULL] [NULL]
70 [NULL] [NULL]
71 [NULL] [NULL]
72 [NULL] [NULL]
73 [NULL] [NULL]
74 [NULL] [NULL]
75 [NULL] [NULL]
76 [NULL] [NULL]
77 [NULL] [NULL]
78 [NULL] [NULL]
79 [NULL] [NULL]
8 [NULL] [NULL]
80 [NULL] [NULL]
81 [NULL] [NULL]
82 [NULL] [NULL]
83 [NULL] [NULL]
84 [NULL] [NULL]
85 [NULL] [NULL]
86 [NULL] [NULL]
87 [NULL] [NULL]
88 [NULL] [NULL]
89 [NULL] [NULL]
9 [NULL] [NULL]
90 [NULL] [NULL]
91 [NULL] [NULL]
92 [NULL] [NULL]
93 [NULL] [NULL]
94 [NULL] [NULL]
95 [NULL] [NULL]
96 [NULL] [NULL]
97 [NULL] [NULL]
98 [NULL] [NULL]
99 [NULL] [NULL]
HSUPDATE
DUMP_TABLE
0 hoge [NULL]
1 hoge [NULL]
10 hoge [NULL]
100 hoge [NULL]
101 hoge [NULL]
102 hoge [NULL]
103 hoge [NULL]
104 hoge [NULL]
105 hoge [NULL]
106 hoge [NULL]
107 hoge [NULL]
108 hoge [NULL]
109 hoge [NULL]
11 hoge [NULL]
110 hoge [NULL]
111 hoge [NULL]
112 hoge [NULL]
113 hoge [NULL]
114 hoge [NULL]
115 hoge [NULL]
116 hoge [NULL]
117 hoge [NULL]
118 hoge [NULL]
119 hoge [NULL]
12 hoge [NULL]
120 hoge [NULL]
121 hoge [NULL]
122 hoge [NULL]
123 hoge [NULL]
124 hoge [NULL]
125 hoge [NULL]
126 hoge [NULL]
127 hoge [NULL]
128 hoge [NULL]
129 hoge [NULL]
13 hoge [NULL]
130 hoge [NULL]
131 hoge [NULL]
132 hoge [NULL]
133 hoge [NULL]
134 hoge [NULL]
135 hoge [NULL]
136 hoge [NULL]
137 hoge [NULL]
138 hoge [NULL]
139 hoge [NULL]
14 hoge [NULL]
140 hoge [NULL]
141 hoge [NULL]
142 hoge [NULL]
143 hoge [NULL]
144 hoge [NULL]
145 hoge [NULL]
146 hoge [NULL]
147 hoge [NULL]
148 hoge [NULL]
149 hoge [NULL]
15 hoge [NULL]
150 hoge [NULL]
151 hoge [NULL]
152 hoge [NULL]
153 hoge [NULL]
154 hoge [NULL]
155 hoge [NULL]
156 hoge [NULL]
157 hoge [NULL]
158 hoge [NULL]
159 hoge [NULL]
16 hoge [NULL]
160 hoge [NULL]
161 hoge [NULL]
162 hoge [NULL]
163 hoge [NULL]
164 hoge [NULL]
165 hoge [NULL]
166 hoge [NULL]
167 hoge [NULL]
168 hoge [NULL]
169 hoge [NULL]
17 hoge [NULL]
170 hoge [NULL]
171 hoge [NULL]
172 hoge [NULL]
173 hoge [NULL]
174 hoge [NULL]
175 hoge [NULL]
176 hoge [NULL]
177 hoge [NULL]
178 hoge [NULL]
179 hoge [NULL]
18 hoge [NULL]
180 hoge [NULL]
181 hoge [NULL]
182 hoge [NULL]
183 hoge [NULL]
184 hoge [NULL]
185 hoge [NULL]
186 hoge [NULL]
187 hoge [NULL]
188 hoge [NULL]
189 hoge [NULL]
19 hoge [NULL]
190 hoge [NULL]
191 hoge [NULL]
192 hoge [NULL]
193 hoge [NULL]
194 hoge [NULL]
195 hoge [NULL]
196 hoge [NULL]
197 hoge [NULL]
198 hoge [NULL]
199 hoge [NULL]
2 hoge [NULL]
20 hoge [NULL]
200 hoge [NULL]
201 hoge [NULL]
202 hoge [NULL]
203 hoge [NULL]
204 hoge [NULL]
205 hoge [NULL]
206 hoge [NULL]
207 hoge [NULL]
208 hoge [NULL]
209 hoge [NULL]
21 hoge [NULL]
210 hoge [NULL]
211 hoge [NULL]
212 hoge [NULL]
213 hoge [NULL]
214 hoge [NULL]
215 hoge [NULL]
216 hoge [NULL]
217 hoge [NULL]
218 hoge [NULL]
219 hoge [NULL]
22 hoge [NULL]
220 hoge [NULL]
221 hoge [NULL]
222 hoge [NULL]
223 hoge [NULL]
224 hoge [NULL]
225 hoge [NULL]
226 hoge [NULL]
227 hoge [NULL]
228 hoge [NULL]
229 hoge [NULL]
23 hoge [NULL]
230 hoge [NULL]
231 hoge [NULL]
232 hoge [NULL]
233 hoge [NULL]
234 hoge [NULL]
235 hoge [NULL]
236 hoge [NULL]
237 hoge [NULL]
238 hoge [NULL]
239 hoge [NULL]
24 hoge [NULL]
240 hoge [NULL]
241 hoge [NULL]
242 hoge [NULL]
243 hoge [NULL]
244 hoge [NULL]
245 hoge [NULL]
246 hoge [NULL]
247 hoge [NULL]
248 hoge [NULL]
249 hoge [NULL]
25 hoge [NULL]
250 hoge [NULL]
251 hoge [NULL]
252 hoge [NULL]
253 hoge [NULL]
254 hoge [NULL]
255 hoge [NULL]
26 hoge [NULL]
27 hoge [NULL]
28 hoge [NULL]
29 hoge [NULL]
3 hoge [NULL]
30 hoge [NULL]
31 hoge [NULL]
32 hoge [NULL]
33 hoge [NULL]
34 hoge [NULL]
35 hoge [NULL]
36 hoge [NULL]
37 hoge [NULL]
38 hoge [NULL]
39 hoge [NULL]
4 hoge [NULL]
40 hoge [NULL]
41 hoge [NULL]
42 hoge [NULL]
43 hoge [NULL]
44 hoge [NULL]
45 hoge [NULL]
46 hoge [NULL]
47 hoge [NULL]
48 hoge [NULL]
49 hoge [NULL]
5 hoge [NULL]
50 hoge [NULL]
51 hoge [NULL]
52 hoge [NULL]
53 hoge [NULL]
54 hoge [NULL]
55 hoge [NULL]
56 hoge [NULL]
57 hoge [NULL]
58 hoge [NULL]
59 hoge [NULL]
6 hoge [NULL]
60 hoge [NULL]
61 hoge [NULL]
62 hoge [NULL]
63 hoge [NULL]
64 hoge [NULL]
65 hoge [NULL]
66 hoge [NULL]
67 hoge [NULL]
68 hoge [NULL]
69 hoge [NULL]
7 hoge [NULL]
70 hoge [NULL]
71 hoge [NULL]
72 hoge [NULL]
73 hoge [NULL]
74 hoge [NULL]
75 hoge [NULL]
76 hoge [NULL]
77 hoge [NULL]
78 hoge [NULL]
79 hoge [NULL]
8 hoge [NULL]
80 hoge [NULL]
81 hoge [NULL]
82 hoge [NULL]
83 hoge [NULL]
84 hoge [NULL]
85 hoge [NULL]
86 hoge [NULL]
87 hoge [NULL]
88 hoge [NULL]
89 hoge [NULL]
9 hoge [NULL]
90 hoge [NULL]
91 hoge [NULL]
92 hoge [NULL]
93 hoge [NULL]
94 hoge [NULL]
95 hoge [NULL]
96 hoge [NULL]
97 hoge [NULL]
98 hoge [NULL]
99 hoge [NULL]
